"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildDefaultContext = exports.buildDefaultConfig = exports.defaultPathFormat = exports.defaultCallbackPosition = void 0;
exports.defaultCallbackPosition = 'preWalk';
const defaultPathFormat = (key, isArr) => isArr ? `[${key}]` : `["${key}"]`;
exports.defaultPathFormat = defaultPathFormat;
function buildDefaultConfig() {
    return {
        traversalMode: 'depth',
        rootObjectCallbacks: true,
        runCallbacks: true,
        graphMode: 'finiteTree',
        parallelizeAsyncCallbacks: false,
        callbacks: []
    };
}
exports.buildDefaultConfig = buildDefaultConfig;
function buildDefaultContext(config) {
    return {
        config: Object.assign(Object.assign({}, buildDefaultConfig()), config),
        nodes: {},
        seenObjects: [],
        callbacksByPosition: {},
    };
}
exports.buildDefaultContext = buildDefaultContext;
